unit hiImg_Edge;

interface

uses Windows,Kol,Share,Img_Draw;

const
Edge: array[0..7] of cardinal = (EDGE_RAISED,EDGE_SUNKEN,EDGE_BUMP,EDGE_ETCHED,BDR_RAISEDINNER,BDR_SUNKENINNER,BDR_RAISEDOUTER,BDR_SUNKENOUTER);         
 
{$I share.inc}

type
  THIImg_Edge = class(THIDraw2PR)
   private
   public
    _prop_View: integer;
    _prop_bfLeft: boolean;
    _prop_bfTop: boolean;        
    _prop_bfRight: boolean;
    _prop_bfBottom: boolean;    
    _prop_bfSoft: boolean;
    _prop_bfFlat: boolean; 
    _prop_bfMono: boolean; 
    _prop_bfMiddle: boolean; 
    _prop_bfDiagonal: boolean; 
    _prop_bfAdjust: boolean; 
            
    _data_View: THI_Event;
    procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation

procedure THIImg_Edge._work_doDraw;
var   dt: TData;
      rect: TRect;
      tp: integer;
      flags: cardinal;
begin
   dt := _Data;
TRY
   if not ImgGetDC(_Data) then exit;
   ReadXY(_Data);
   ImgNewSizeDC;
   tp := ReadInteger(_Data,_data_View,_prop_View);
   flags := $0;
   if _prop_bfLeft     then flags := flags OR $00000001; 
   if _prop_bfTop      then flags := flags OR $00000002; 
   if _prop_bfRight    then flags := flags OR $00000004; 
   if _prop_bfBottom   then flags := flags OR $00000008; 
   if _prop_bfDiagonal then flags := flags OR $00000010;  
   if _prop_bfMiddle   then flags := flags OR $00000800; 
   if _prop_bfSoft     then flags := flags OR $00001000; 
   if _prop_bfAdjust   then flags := flags OR $00002000; 
   if _prop_bfFlat     then flags := flags OR $00004000; 
   if _prop_bfMono     then flags := flags OR $00008000; 
   SetRect(rect, x1, y1, x2, y2);
   DrawEdge(pDC, rect, Edge[tp], flags);

FINALLY
   ImgReleaseDC;
   _hi_CreateEvent(_Data,@_event_onDraw,dt);
END;
end;

end.